Index: branches/2016/dev_v3_6_STABLE_r6506_AGRIF_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/iodef.xml
===================================================================
--- branches/2016/dev_v3_6_STABLE_r6506_AGRIF_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/iodef.xml	(revision 7593)
+++ branches/2016/dev_v3_6_STABLE_r6506_AGRIF_LIM3/NEMOGCM/CONFIG/ORCA2_LIM3/EXP00/iodef.xml	(revision 7594)
@@ -61,6 +61,6 @@
 	<file id="file2" name_suffix="_SBC" description="surface fluxes variables" > <!-- time step automaticaly defined based on nn_fsbc -->
 	  <field field_ref="empmr"        name="wfo"      />
-      <field field_ref="emp_oce"      name="emp_oce"  long_name="Evap minus Precip over ocean"              />
-      <field field_ref="emp_ice"      name="emp_ice"  long_name="Evap minus Precip over ice"                />
+	  <field field_ref="emp_oce"      name="emp_oce"  long_name="Evap minus Precip over ocean"              />
+	  <field field_ref="emp_ice"      name="emp_ice"  long_name="Evap minus Precip over ice"                />
 	  <field field_ref="qsr_oce"      name="qsr_oce"  />
 	  <field field_ref="qns_oce"      name="qns_oce"  />
@@ -215,60 +215,34 @@
           <field field_ref="bgfrctem"     name="bgfrctem"   />
           <field field_ref="bgfrcsal"     name="bgfrcsal"   />
-
-          <field field_ref="ibgvoltot"    name="ibgvoltot"  />
-          <field field_ref="sbgvoltot"    name="sbgvoltot"  />
-          <field field_ref="ibgarea"      name="ibgarea"    />
-          <field field_ref="ibgsaline"    name="ibgsaline"  />
-          <field field_ref="ibgtemper"    name="ibgtemper"  />
-          <field field_ref="ibgheatco"    name="ibgheatco"  />
-          <field field_ref="sbgheatco"    name="sbgheatco"  />
-          <field field_ref="ibgsaltco"    name="ibgsaltco"  />
-
-          <field field_ref="ibgvfx"       name="ibgvfx"     />
-          <field field_ref="ibgvfxbog"    name="ibgvfxbog"  />
-          <field field_ref="ibgvfxopw"    name="ibgvfxopw"  />
-          <field field_ref="ibgvfxsni"    name="ibgvfxsni"  />
-          <field field_ref="ibgvfxdyn"    name="ibgvfxdyn"  />
-          <field field_ref="ibgvfxbom"    name="ibgvfxbom"  />
-          <field field_ref="ibgvfxsum"    name="ibgvfxsum"  />
-          <field field_ref="ibgvfxres"    name="ibgvfxres"  />
-          <field field_ref="ibgvfxspr"    name="ibgvfxspr"  />
-          <field field_ref="ibgvfxsnw"    name="ibgvfxsnw"  />
-          <field field_ref="ibgvfxsub"    name="ibgvfxsub"  />
-
-          <field field_ref="ibgsfx"       name="ibgsfx"     />
-          <field field_ref="ibgsfxbri"    name="ibgsfxbri"  />
-          <field field_ref="ibgsfxdyn"    name="ibgsfxdyn"  />
-          <field field_ref="ibgsfxres"    name="ibgsfxres"  />
-          <field field_ref="ibgsfxbog"    name="ibgsfxbog"  />
-          <field field_ref="ibgsfxopw"    name="ibgsfxopw"  />
-          <field field_ref="ibgsfxsni"    name="ibgsfxsni"  />
-          <field field_ref="ibgsfxbom"    name="ibgsfxbom"  />
-          <field field_ref="ibgsfxsum"    name="ibgsfxsum"  />
-
-          <field field_ref="ibghfxdhc"    name="ibghfxdhc"  />
-          <field field_ref="ibghfxspr"    name="ibghfxspr"  />
-
-          <field field_ref="ibghfxres"    name="ibghfxres"  />
-          <field field_ref="ibghfxsub"    name="ibghfxsub"  />
-          <field field_ref="ibghfxdyn"    name="ibghfxdyn"  />
-          <field field_ref="ibghfxthd"    name="ibghfxthd"  />
-          <field field_ref="ibghfxsum"    name="ibghfxsum"  />
-          <field field_ref="ibghfxbom"    name="ibghfxbom"  />
-          <field field_ref="ibghfxbog"    name="ibghfxbog"  />
-          <field field_ref="ibghfxdif"    name="ibghfxdif"  />
-          <field field_ref="ibghfxopw"    name="ibghfxopw"  />
-          <field field_ref="ibghfxout"    name="ibghfxout"  />
-          <field field_ref="ibghfxin"     name="ibghfxin"   />
-          <field field_ref="ibghfxsnw"    name="ibghfxsnw"  />
-
-          <field field_ref="ibgfrcvol"    name="ibgfrcvol"  />
-          <field field_ref="ibgfrcsfx"    name="ibgfrcsfx"  />
-          <field field_ref="ibgvolgrm"    name="ibgvolgrm"  />
-
         </file>
 
+        <file id="file8" name_suffix="_SBC_scalar" description="scalar variables" enabled=".true." >
+          <!-- global contents -->
+	  <field field_ref="ibgvol_tot"    name="ibgvol_tot"   />
+	  <field field_ref="sbgvol_tot"    name="sbgvol_tot"   />
+	  <field field_ref="ibgarea_tot"   name="ibgarea_tot"  />
+	  <field field_ref="ibgsalt_tot"   name="ibgsalt_tot"  />
+	  <field field_ref="ibgheat_tot"   name="ibgheat_tot"  />
+	  <field field_ref="sbgheat_tot"   name="sbgheat_tot"  />
+	  
+	  <!-- global drifts (conservation checks) -->
+	  <field field_ref="ibgvolume"     name="ibgvolume"    />
+	  <field field_ref="ibgsaltco"     name="ibgsaltco"    />
+	  <field field_ref="ibgheatco"     name="ibgheatco"    />
+	  <field field_ref="ibgheatfx"     name="ibgheatfx"    />
+	  
+	  <!-- global forcings  -->
+	  <field field_ref="ibgfrcvoltop"  name="ibgfrcvoltop" />
+	  <field field_ref="ibgfrcvolbot"  name="ibgfrcvolbot" />
+	  <field field_ref="ibgfrctemtop"  name="ibgfrctemtop" />
+	  <field field_ref="ibgfrctembot"  name="ibgfrctembot" />
+	  <field field_ref="ibgfrcsal"     name="ibgfrcsal"    />
+	  <field field_ref="ibgfrchfxtop"  name="ibgfrchfxtop" />
+	  <field field_ref="ibgfrchfxbot"  name="ibgfrchfxbot" />
+        </file>
+	  
+
 	<!--
-	<file id="file8" name_suffix="_Tides" description="tidal harmonics" >
+	<file id="file9" name_suffix="_Tides" description="tidal harmonics" >
 	  <field field_ref="M2x"          name="M2x"      long_name="M2 Elevation harmonic real part"                       />
 	  <field field_ref="M2y"          name="M2y"      long_name="M2 Elevation harmonic imaginary part"                  />