Index: /branches/2016/dev_merge_2016/NEMOGCM/CONFIG/WAD_TEST_CASES/MY_DOCS/WAD_doc.tex
===================================================================
--- /branches/2016/dev_merge_2016/NEMOGCM/CONFIG/WAD_TEST_CASES/MY_DOCS/WAD_doc.tex	(revision 7597)
+++ /branches/2016/dev_merge_2016/NEMOGCM/CONFIG/WAD_TEST_CASES/MY_DOCS/WAD_doc.tex	(revision 7598)
@@ -115,5 +115,18 @@
 
 Let the fluxes on the $m$th iteration step be denoted by $\mathrm{flxu}^{(m)}$ and
-$\mathrm{flxv}^{(m)}$. The iteration is initialised by setting
+$\mathrm{flxv}^{(m)}$.  Then the adjustment is achieved by seeking a set of coefficients,
+$\mathrm{zcoef}_{i,j}^{(m)}$ such that:
+
+\begin{equation} \label{dyn_wd_continuity_coef}
+\begin{split}
+\mathrm{zzflxp}^{(m)}_{i,j} =& \mathrm{zcoef}_{i,j}^{(m)} \mathrm{zzflxp}^{(0)}_{i,j} \\
+\mathrm{zzflxn}^{(m)}_{i,j} =& \mathrm{zcoef}_{i,j}^{(m)} \mathrm{zzflxn}^{(0)}_{i,j}
+\end{split}
+\end{equation} 
+ 
+where the coefficients are $1.0$ generally but can vary between $0.0$ and $1.0$ around
+cells that would otherwise dry.
+
+The iteration is initialised by setting
 
 \begin{equation} \label{dyn_wd_zzflx_initial}
@@ -130,30 +143,45 @@
 \end{equation} 
 
-Where this is the case each of the fluxes out of this $(i,j)$ cell are multiplied by the
-factor $\mathrm{zcoef}_{i,j}$:
-
-\begin{equation} \label{dyn_wd_continuity_coef}
+Rearranging (\ref{dyn_wd_continuity_if}) we can obtain an expression for the maximum
+outward flux that can be allowed and still maintain the minimum wet depth:
+
+\begin{equation} \label{dyn_wd_max_flux}
 \begin{split}
-\mathrm{zcoef}_{i,j} = \Big[ (h_{i,j}(t_e) & - \mathrm{rn\_wdmin1} - \mathrm{rn\_wdmin2})  \frac{e_1 e_2}{\Delta t} \phantom{]} \\
-\phantom{[} & -  \mathrm{zzflxn}^{(m)}_{i,j} \Big] \frac{1}{ \mathrm{zzflxp}^{(m)}_{i,j} } 
+\mathrm{zzflxp}^{(m+1)}_{i,j} = \Big[ (h_{i,j}(t_e) & - \mathrm{rn\_wdmin1} - \mathrm{rn\_wdmin2})  \frac{e_1 e_2}{\Delta t} \phantom{]} \\
+\phantom{[} & -  \mathrm{zzflxn}^{(m)}_{i,j} \Big]
 \end{split}
-\end{equation} 
-
-Note that the flux across the ``eastern'' face of the $(i,j)$th cell is only updated at
-the $m+1$th iteration if that flux at the $m$th iteration is out of the $(i,j)$th cell. If
-that is the case then the flux across that face is into the $(i+1,j)$ cell and that flux
-will not be updated by the calculation for the $(i+1,j)$th cell. In this sense the updates
-to the fluxes across the faces of the cells do not ``compete'' (they do not over-write
-each other) and one would expect the scheme to converge relatively quickly. The scheme is
-also flux based so conserves mass.
+\end{equation}
+
+Note a small tolerance ($\mathrm{rn\_wdmin2}$) has been introduced here {\it [Q: Why is
+this necessary/desirable?]}. Substituting from (\ref{dyn_wd_continuity_coef}) gives an
+expression for the coefficient needed to multiply the outward flux at this cell in order
+to avoid drying. 
+
+\begin{equation} \label{dyn_wd_continuity_nxtcoef}
+\begin{split}
+\mathrm{zcoef}^{(m+1)}_{i,j} = \Big[ (h_{i,j}(t_e) & - \mathrm{rn\_wdmin1} - \mathrm{rn\_wdmin2})  \frac{e_1 e_2}{\Delta t} \phantom{]} \\
+\phantom{[} & -  \mathrm{zzflxn}^{(m)}_{i,j} \Big] \frac{1}{ \mathrm{zzflxp}^{(0)}_{i,j} } 
+\end{split}
+\end{equation} 
+
+Only the outward flux components are altered but, of course, outward fluxes from one cell
+are inward fluxes to adjacent cells and the balance in these cells may need subsequent
+adjustment; hence the iterative nature of this scheme.  Note, for example, that the flux
+across the ``eastern'' face of the $(i,j)$th cell is only updated at the $m+1$th iteration
+if that flux at the $m$th iteration is out of the $(i,j)$th cell. If that is the case then
+the flux across that face is into the $(i+1,j)$ cell and that flux will not be updated by
+the calculation for the $(i+1,j)$th cell. In this sense the updates to the fluxes across
+the faces of the cells do not ``compete'' (they do not over-write each other) and one
+would expect the scheme to converge relatively quickly. The scheme is also flux based so
+conserves mass.
 
 The ROMS scheme to prevent drying out of a cell is somewhat simpler. It specifies that if
 a tracer cell is dry (the water depth is less than $\mathrm{rn\_wdmin1}$) on the backward
 timestep, $t_e$, then any outward flux through its cell faces should be set to zero. This
-scheme has a clear physical rationale.  It has not yet been implemented within NEMO but it
-could be. One objection to the ROMS scheme is that it introduces a spurious step function
-in the flux out of a cell as the water depth in the cell passes through the ``critical''
-value $\mathrm{rn\_wdmin1}$. One might replace this step function with a smoother function
-of the water depth in the cell from which the flux originates.
+scheme has a clear physical rationale. This scheme is equivalent to setting
+$\mathrm{zcoef}^{(m+1)}_{i,j}$ to $0.0$ whenever a cell is at risk of drying.  One
+objection to the ROMS scheme is that it introduces a spurious step function in the flux
+out of a cell as the water depth in the cell passes through the ``critical'' value
+$\mathrm{rn\_wdmin1}$.
 
 %----------------------------------------------------------------------------------------