Index: branches/UKMO/dev_r5518_GO6_package_for_static_diagnostics/NEMOGCM/CONFIG/SHARED/field_def.xml
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_for_static_diagnostics/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 7598)
+++ branches/UKMO/dev_r5518_GO6_package_for_static_diagnostics/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 7599)
@@ -117,14 +117,14 @@
       </field_group>
 
-      <field_group id="constant_fields" grid_ref="grid_T_2D" >
+      <field_group id="constant_fields" grid_ref="grid_T_2D" operation="once" >
          <field id="areacello" long_name="Ocean Grid-Cell Area" standard_name="cell_area" unit="m2" />
-         <field id="sftof" long_name="Sea Area Fraction", standard_name="sea_area_fraction" unit="%" />
+         <field id="sftof" long_name="Sea Area Fraction" standard_name="sea_area_fraction" unit="%" />
          <field id="deptho" long_name="Sea Floor Depth Below Geoid" standard_name="sea_floor_depth_below_geoid" unit="m" />
-         <field id="avtb" long_name="Ocean Vertical Tracer Diffusivity due to Background" standard_name="ocean_vertical_tracer_diffusivity_due_to_background" unit="m2 s-1" />
-         <field id="avmb" long_name="Ocean Vertical Momentum Diffusivity due to Background" standard_name="ocean_vertical_momentum_diffusivity_due_to_background" unit="m2 s-1" />
+         <field id="avtb" long_name="Ocean Vertical Tracer Diffusivity due to Background" standard_name="ocean_vertical_tracer_diffusivity_due_to_background" unit="m2 s-1" grid_ref="grid_T_3D" />
+         <field id="avmb" long_name="Ocean Vertical Momentum Diffusivity due to Background" standard_name="ocean_vertical_momentum_diffusivity_due_to_background" unit="m2 s-1" grid_ref="grid_T_3D" />
          <field id="ahmt_blp" long_name="Ocean Momentum XY Biharmonic Diffusivity" standard_name="ocean_momentum_xy_biharmonic_diffusivity"  unit="m4 s-1" />
          <field id="ahmt_lap" long_name="Ocean Momentum XY Laplacian Diffusivity" standard_name="ocean_momentum_xy_laplacian_diffusivity"  unit="m2 s-1" />
          <field id="aht2D" long_name="ocean tracer epineutral laplacian diffusivity" standard_name="ocean_tracer_epineutral_laplacian_diffusivity"  unit="m2 s-1" />
-         <field id="hfgeou" long_name="Upward Geothermal Heat Flux at Sea Floor" standard_name="upward_geothermal_heat_flux_at_sea_floor" units="W m-2" />
+         <field id="hfgeou" long_name="Upward Geothermal Heat Flux at Sea Floor" standard_name="upward_geothermal_heat_flux_at_sea_floor" unit="W m-2" />
       </field_group>
 
Index: branches/UKMO/dev_r5518_GO6_package_for_static_diagnostics/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_for_static_diagnostics/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 7598)
+++ branches/UKMO/dev_r5518_GO6_package_for_static_diagnostics/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 7599)
@@ -29,4 +29,5 @@
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
    USE wrk_nemo        ! Memory Allocation
+   USE iom
    USE timing          ! Timing
 
@@ -91,5 +92,5 @@
                 ENDDO
              ENDDO
-             CALL iom_put("ahmt_blb", ztmp)
+             CALL iom_put("ahmt_blp", ztmp)
              CALL wrk_dealloc(jpi, jpj, ztmp)
           ENDIF
Index: branches/UKMO/dev_r5518_GO6_package_for_static_diagnostics/NEMOGCM/NEMO/OPA_SRC/TRA/trabbc.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_for_static_diagnostics/NEMOGCM/NEMO/OPA_SRC/TRA/trabbc.F90	(revision 7598)
+++ branches/UKMO/dev_r5518_GO6_package_for_static_diagnostics/NEMOGCM/NEMO/OPA_SRC/TRA/trabbc.F90	(revision 7599)
@@ -91,8 +91,12 @@
       IF( kt == nit000 ) THEN
       !Output the geothermal heat flux once for CMIP6 diagnostics
-         wrk_alloc(jpi, jpj, ztmp)
-         ztmp(:,:) = qgh_trd0(:,:)*rcp_rau0
+         CALL wrk_alloc(jpi, jpj, ztmp)
+         DO jj=1,jpj
+            DO ji=1,jpi
+               ztmp(ji,jj) = qgh_trd0(ji,jj)*rau0_rcp
+            ENDDO
+         ENDDO
          CALL iom_put( 'hfgeou', ztmp )
-         wrk_dealloc(jpi, jpj, ztmp)
+         CALL wrk_dealloc(jpi, jpj, ztmp)
       ENDIF
 
Index: branches/UKMO/dev_r5518_GO6_package_for_static_diagnostics/NEMOGCM/NEMO/OPA_SRC/TRA/traldf.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_for_static_diagnostics/NEMOGCM/NEMO/OPA_SRC/TRA/traldf.F90	(revision 7598)
+++ branches/UKMO/dev_r5518_GO6_package_for_static_diagnostics/NEMOGCM/NEMO/OPA_SRC/TRA/traldf.F90	(revision 7599)
@@ -31,4 +31,5 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE wrk_nemo        ! Memory allocation
+   USE iom
    USE timing          ! Timing
 
@@ -78,6 +79,5 @@
 
 #ifdef key_traldf_c2d
-      IF (kt == nit000) THEN
-         CALL iom_put( "aht2D", ahtw)
+      IF (kt == nit000)    CALL iom_put( "aht2D", ahtw)
 #endif
 